MODULE nfaculty

  INTERFACE OPERATOR (.fac.)
    MODULE PROCEDURE faculty
  END INTERFACE 

  CONTAINS

  RECURSIVE FUNCTION faculty(n) RESULT(res)
    IMPLICIT NONE
    INTEGER,INTENT(IN) :: n
    INTEGER :: res

    IF (n == 1) THEN
      res = 1
    ELSE
      res = n * faculty(n - 1)
    END IF
  END FUNCTION faculty

END MODULE nfaculty
